/**
 * @file main.cpp
 * @brief Primer programa Qt para SII
 *
 * Probando el TVentanuco desde la linea de ordenes de Windows
 *
 * @author Angel Perles
 */


#include <QApplication>
#include "tventanuco.h"
#include "tdesignerventanuco.h"

int main(int argc, char *argv[])
{
        QApplication app(argc, argv);
        int resultado;

        // un ventanuco creado dinamicamente
        TVentanuco *vent1;
        vent1 = new TVentanuco("(vent1) Estooo, probando ventanuco");
        vent1->show();

        // un ventanuco creado estaticamente como variable automatica
        TVentanuco vent2("(vent2) Y ahora otro ventanuco");
        vent2.show();

        // cuando termine la aplicacion, no se habra hecho "delete" de vent1,
        // pero si que se habra llamado automaticamente al destructor de vent2.
        // recordadme que os explique lo que pasa

        // el estornudado y el infectado estan ahora conectados, a contagiarse!
        QObject::connect(vent1,SIGNAL(senyalEstornudado(const char*)),&vent2,SLOT(ranuraInfeccion(const char*)));
        QObject::connect(&vent2,SIGNAL(senyalEstornudado(const char*)),vent1,SLOT(ranuraInfeccion(const char*)));

        TDesignerVentanuco *vent3;
        vent3 = new TDesignerVentanuco(NULL);
        vent3->show();

        resultado = app.exec(); // a funcionar! empieza el bucle de eventos.

        return resultado;
}
