/**
 * @file tventanuco.h
 * @brief Primer programa Qt para SII
 *
 * @author Angel Perles
 */

// hay que meter la cabecera de los objetos Qt que vayas a usar
#include <QPushButton>
#include <QVBoxLayout>
#include <QLabel>
#include <QLineEdit>

#include "tventanuco.h"


TVentanuco::TVentanuco(const char *mensaje)
    : QDialog()  // llamamos al constructor de la base
{
    // ponemos el mensaje en el titulo del dialog
    setWindowTitle(mensaje);

    //crear el distribuidor de objetos
    lyDistribuidor = new QVBoxLayout(this);

    // creamos una etiqueta y la metemos en el "layout"
    lbEtiqueta = new QLabel(tr("A ver si esto va o no"));
    lyDistribuidor->addWidget(lbEtiqueta);

    // parar jugar con los "layout", meto un "muelle"
    lyDistribuidor->addStretch();

    // ahora una linea de edicion
    leEdicion = new QLineEdit;
    lyDistribuidor->addWidget(leEdicion);

    // ahora un boton
    btToquetear = new QPushButton(tr("Tocar narices"));
    lyDistribuidor->addWidget(btToquetear);

    // ahora el boton de cerrar
    btCerrar = new QPushButton(tr("Salir"));
    lyDistribuidor->addWidget(btCerrar);


    // vamos a conectar cosas ...
    // para cerrar el dialogo
    connect(btCerrar,SIGNAL(clicked()),this,SLOT(close()));

    // para borrar la linea de edicion al pulsar un boton
    //connect(btToquetear,SIGNAL(clicked()),leEdicion,SLOT(clear()));

    // para escribir un texto en la linea de edicion al pulsar un boton
    // en este caso hace falta crear slot propio
    connect(btToquetear,SIGNAL(clicked()),this,SLOT(ranuraSaludo()));

    // conectar el boton btToquetear a la ranura ranuraCosquillas
    connect(btToquetear,SIGNAL(clicked()),this,SLOT(ranuraCosquillas()));
}

/**
 * @brief Un slot se implementa igual que un metodo normal
 */
void TVentanuco::ranuraSaludo(void)
{
    //lbEtiqueta->setText(tr("Good morning SII!"));
    leEdicion->setText(tr("Good morning SII!"));
}

/**
 * @brief Un slot al que llegan "microbios" desde el exterior
 *
 * @param nombre_microbio pues eso
 */
void TVentanuco::ranuraInfeccion(const char* nombre_microbio)
{

    setWindowTitle(nombre_microbio);    // lo ponemos como titulo de la ventana
}

/**
 * @brief Vamos a estornudar cada 5 veces que se entra en esta funcion
 */
void TVentanuco::ranuraCosquillas(void)
{
    static int i = 0;
    i++;
    if (i == 5) {
        i = 0;
        emit senyalEstornudado("Streptococus burrus");
    }
}

